﻿//連続可変低周波発振器 Ver.1.2  　2012.7　高木伸雄　

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NAudio.Wave;
using System.Windows;


namespace WindowsFormsApplication1
{

    //***********************************************************************************************
    //　　　　　　　　Form1　Class
    //***********************************************************************************************
    //以下のコメントで、スライダー等による周波数入力発振（波）をモノラル（波）発振、連続可変発振とも表記している。
    //同様に、周波数入力発振（波）をステレオ（波）発振とも表記している。

    public partial class Form1 : Form
    {
        WaveOut ConwaveOut;               //連続可変発振対応（NAudio インスタンス）
        WaveOut LeftwaveOut;              //ステレオ左発振対応（NAudio インスタンス）
        WaveOut RightwaveOut;             //ステレオ右発振対応（NAudio インスタンス）
        WaveOut BothwaveOut;              //左右発振対応（NAudio インスタンス）
        WaveOut MixwaveOut;               //混合発振対応（NAudio インスタンス）
        ConOscillator Conoscillator;      //連続可変発振インスタンス
        LeftOscillator Leftoscillator;    //ステレオ左発振インスタンス
        RightOscillator Rightoscillator;  //ステレオ右発振インスタンス
        BothOscillator Bothoscillator;    //左右発振インスタンス
        MixOscillator Mixoscillator;      //混合発振インスタンス
        short amp = 9800;                 //音量設定用変数
        bool conOsc_bool = false;         //モノラル（連続可変）発振ボタンが押されたら true、停止ボタンが押されたら false
        bool leftOsc_bool = false;        //ステレオ左発振ボタンが押されたら true、停止ボタンが押されたら false
        bool rightOsc_bool = false;       //ステレオ右発振ボタンが押されたら true、停止ボタンが押されたら false
        bool bothOsc_bool = false;        //左右発振ボタンが押されたら true、停止ボタンが押されたら false
        bool mixOsc_bool = false;         //混合発振ボタンが押されたら true、停止ボタンが押されたら false
        int X = 1;                        //倍率切り替え用変数
        double T = 100;                   //グラフ表示フルスケール切り替え用変数
        bool monograph_bool = false;      //モノラル波グラフボタン オン、オフ用 boolean
        bool leftgraph_bool = false;      //ステレオ左波グラフボタン オン、オフ用 boolean
        bool rightgraph_bool = false;     //ステレオ右波グラフボタン オン、オフ用 boolean
        bool mixgraph_bool = false;       //合成波グラフボタン オン、オフ用 boolean
        bool Vis_bool = false;            //グラフ領域「ｸﾞﾗﾌ開」「ｸﾞﾗﾌ閉」切り替え用 boolean

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)  //初期フォームのサイズ（グラフ領域「閉」状態）
        {
            this.Size = new Size(485, 221);
        }

        //--------------------------------以下 ステレオ関係 発振ボタン ---------------------------------------------

        private void button1_Click(object sender, EventArgs e)  //右発振ボタン
        {
            string RightStr = textBox1.Text;  //右周波数
            string phaseStr = textBox3.Text; //位相差
            if (RightStr == "")
            {
                textBox1.Text = "整数入力";
            }
            else if (System.Text.RegularExpressions.Regex.IsMatch(textBox1.Text, "^[0-9]+$") == false)  // textBox1のテキストが整数値か判断する
            {
                MessageBox.Show("周波数は整数のみ可");
            }
            else if (phaseStr == "")
            {
                MessageBox.Show("位相差に整数値を入力");
            }
            else if (System.Text.RegularExpressions.Regex.IsMatch(textBox3.Text, "^[0-9]+$") == false)  // textBox3のテキストが整数値か判断する
            {
                MessageBox.Show("位相差は整数のみ可。");
            }
            else
            {
                leftOsc_bool = false;
                rightOsc_bool = true;
                bothOsc_bool = false;
                mixOsc_bool = false;

                RightOscillate();
            }
        }

        private void button14_Click(object sender, EventArgs e)  //左発振ボタン
        {
            string  LeftStr = textBox6.Text;  //左周波数
            if (LeftStr == "")
            {
                textBox6.Text = "整数入力";
            }
            else if (System.Text.RegularExpressions.Regex.IsMatch(textBox6.Text, "^[0-9]+$") == false)  // textBox6のテキストが整数値か判断する
            {
                MessageBox.Show("周波数は整数のみ可");
            }
            else
            {
                rightOsc_bool = false;
                leftOsc_bool = true;
                bothOsc_bool = false;
                mixOsc_bool = false;

                LeftOscillate();
            }
        }

        private void button17_Click(object sender, EventArgs e)   //左右発振ボタン
        {
             if (TextBoxCheck() == true)
            {
                rightOsc_bool = false;
                leftOsc_bool = false;
                bothOsc_bool = true;
                mixOsc_bool = false;

                BothOscillate();
            }
        }

        private void button25_Click(object sender, EventArgs e)   //混合発振ボタン
        {
            if(TextBoxCheck() == true)
            {
                rightOsc_bool = false;
                leftOsc_bool = false;
                bothOsc_bool = false;
                mixOsc_bool = true;

                MixOscillate();
            }
        }
        //----------------------------以上 ステレオ関係 発振ボタン -----以下、テキストボックスの検査・表示等　----------------------------------------

        private bool TextBoxCheck()    //テキストボックスの状態を検査
        {
            string RightStr = textBox1.Text;  //右周波数
            string LeftStr = textBox6.Text;  //左周波数
            string PhaseStr = textBox3.Text; //位相差
            bool Boo = false;

            if (RightStr == "")
            {
                textBox1.Text = "整数入力";
                Boo = false;
            }
            else if (System.Text.RegularExpressions.Regex.IsMatch(textBox1.Text, "^[0-9]+$") == false)  // textBox1のテキストが整数値か判断する
            {
                MessageBox.Show("周波数は整数のみ可");
                Boo = false;
            }
            else if (LeftStr == "")
            {
                textBox6.Text = "整数入力";
                Boo = false;
            }
            else if (System.Text.RegularExpressions.Regex.IsMatch(textBox6.Text, "^[0-9]+$") == false)  // textBox6のテキストが整数値か判断する
            {
                MessageBox.Show("周波数は整数のみ可");
                Boo = false;
            }

            else if (PhaseStr == "")
            {
                MessageBox.Show("位相差に整数値を入力");
                Boo = false;
            }
            else if (System.Text.RegularExpressions.Regex.IsMatch(textBox3.Text, "^[0-9]+$") == false)  // textBox3のテキストが整数値か判断する
            {
                MessageBox.Show("位相差は整数のみ可。");
                Boo = false;
            }
            else
            {
                Boo = true;
            }
            return Boo;
        }


        private void textBox1_Enter(object sender, EventArgs e)　//「整数入力」の表示の時、ステレオ右のテキストボックスを空にする
        {
            if (textBox1.Text == "整数入力")
            {
                textBox1.Text = "";
            }
 //           if ((System.Text.RegularExpressions.Regex.IsMatch(textBox1.Text, "^[0-9]+$") == false))
 //           {
//                MessageBox.Show("整数値を入力してください");
//            }

        }

        private void textBox6_Enter(object sender, EventArgs e)　//「整数入力」の表示の時、ステレオ左のテキストボックスを空にする
        {
            if (textBox6.Text == "整数入力")
            {
                textBox6.Text = "";
            }
        }

        private void textBox2_MouseDown(object sender, MouseEventArgs e)    //テキストボックスに直接数値を入力しようとしたときのメッセージ表示
        {
            MessageBox.Show("スライダーやボタンから入力してください");
        }

        //--------------------------以上、テキストボックスの検査・表示等------以下 ステレオ関係発振実行 ----------------------------------

        private void RightOscillate()　//右発振
        {
            if (rightOsc_bool == true)
            {
                StereoStop();

                if ((RightwaveOut = new WaveOut()) != null)
                {
                    string PhaseStr = textBox3.Text;
                    double Phase = 0;       //位相差（度）
                    double PhaseRad = 0;    //位相差（ラジアン）
                    if (double.TryParse(PhaseStr, out Phase))
                    {
                        PhaseRad = Phase * Math.PI / 180;
                    }

                    double pitch = RightCalculatePitch();   //pitch計算
                    Rightoscillator = new RightOscillator(44100, pitch, PhaseRad);
                    Rightoscillator.Amplitude = amp;
                    RightwaveOut.Init(Rightoscillator);
                    RightwaveOut.Play();
                }
                button1.BackColor = Color.Tan;
                button14.BackColor = Color.Silver;
                button17.BackColor = Color.Silver;
                button25.BackColor = Color.Silver;
            }
        }

        private void LeftOscillate()　//左周波数入力発振
        {
            if (leftOsc_bool == true)
            {
                StereoStop();
 
                if ((LeftwaveOut = new WaveOut()) != null)
                {
                    double pitch = LeftCalculatePitch();   //pitch計算
                    Leftoscillator = new LeftOscillator(44100, pitch);
                    Leftoscillator.Amplitude = amp;
                    LeftwaveOut.Init(Leftoscillator);
                    LeftwaveOut.Play();
                }
                button14.BackColor = Color.Tan;
                button1.BackColor = Color.Silver;
                button17.BackColor = Color.Silver;
                button25.BackColor = Color.Silver;
            }
        }

        private void BothOscillate()  //左右発振
        {
            if (bothOsc_bool == true)
            {
                StereoStop();

                if ((BothwaveOut = new WaveOut()) != null)
                {
                    string PhaseStr = textBox3.Text;
                    double Phase = 0;       //位相差（度）
                    double PhaseRad = 0;    //位相差（ラジアン）
                    if (double.TryParse(PhaseStr, out Phase))
                    {
                        PhaseRad = Phase * Math.PI / 180;
                    }

                    double Rightpitch = RightCalculatePitch();   //右pitch計算
                    double Leftpitch = LeftCalculatePitch();   //左pitch計算
                    Bothoscillator = new BothOscillator(44100, Leftpitch, Rightpitch, PhaseRad);
                    Bothoscillator.Amplitude = amp;
                    BothwaveOut.Init(Bothoscillator);
                    BothwaveOut.Play();
                }
                button17.BackColor = Color.Tan;
                button1.BackColor = Color.Silver;
                button14.BackColor = Color.Silver;
                button25.BackColor = Color.Silver;
            }
        }

        private void MixOscillate()  //混合発振
        {
            if (mixOsc_bool == true)
            {
                StereoStop();

                if ((MixwaveOut = new WaveOut()) != null)
                {
                    string PhaseStr = textBox3.Text;
                    double Phase = 0;       //位相差（度）
                    double PhaseRad = 0;    //位相差（ラジアン）
                    if (double.TryParse(PhaseStr, out Phase))
                    {
                        PhaseRad = Phase * Math.PI / 180;
                    }

                    double Rightpitch = RightCalculatePitch();   //右pitch計算
                    double Leftpitch = LeftCalculatePitch();   //左pitch計算
                    Mixoscillator = new MixOscillator(44100, Leftpitch, Rightpitch, PhaseRad);
                    Mixoscillator.Amplitude = amp;
                    MixwaveOut.Init(Mixoscillator);
                    MixwaveOut.Play();
                }
                button25.BackColor = Color.Tan;
                button17.BackColor = Color.Silver;
                button1.BackColor = Color.Silver;
                button14.BackColor = Color.Silver;
            }

        }

        double RightCalculatePitch()    //右発振用 pitch 計算
        {
            double pitch = 67.34996;
            double fre = 400.0;
            string RightStr = textBox1.Text;
            if (double.TryParse(RightStr, out fre))
            {
                pitch = 12 * (Math.Log10(fre) - Math.Log10(440)) / Math.Log10(2) + 69;
            }
            return pitch;
        }

        double LeftCalculatePitch()    //左発振用 pitch 計算
        {
            double pitch = 67.34996;
            double fre = 400.0;
            string Str = textBox6.Text;
            if (double.TryParse(Str, out fre))
            {
                pitch = 12 * (Math.Log10(fre) - Math.Log10(440)) / Math.Log10(2) + 69;
            }
            return pitch;
        }
        //----------------------以上 ステレオ関係発振実行 -------以下　モノラル（連続可変）発振関係　----------------------------

        private void button5_Click(object sender, EventArgs e)  //モノラル発振ボタン
        {
            continuousOscillate();
            conOsc_bool = true;
        }

        private void continuousOscillate()　//モノラル発振
        {
            if (ConwaveOut != null)
            {
                ConwaveOut.Stop();
                ConwaveOut.Dispose();
                ConwaveOut = null;
            }
            if ((ConwaveOut = new WaveOut()) != null)
            {
                double pitch = ConCalculatePitch();
                Conoscillator = new ConOscillator(44100, pitch);
                Conoscillator.Amplitude = amp;
                ConwaveOut.Init(Conoscillator);
                ConwaveOut.Play();
            }
            button5.BackColor = Color.Tan;
        }

        private void trackBar1_Scroll(object sender, EventArgs e)   //トラックバー（スライダー）スクロール：モノラル波周波数変更
        {
            textBox2.Text = (trackBar1.Value * X).ToString();
            if (conOsc_bool == true)
            {
                Conoscillator.Pitch = ConCalculatePitch();  //Pitch計算
            }
            waveDis();  //波の表示
        }

        double ConCalculatePitch()     //モノラル発振用 pitch 計算
        {
            double pitch = 67.34996;
            double fre = 400.0;
            string Str = textBox2.Text;
            if (double.TryParse(Str, out fre))
            {
                pitch = 12 * (Math.Log10(fre) - Math.Log10(440)) / Math.Log10(2) + 69;
            }
            return pitch;
        }


        private void StereoStop()      //ステレオ発振関係（４つ）発進停止
        {
            if (RightwaveOut != null)
            {
                RightwaveOut.Stop();
                RightwaveOut.Dispose();
                RightwaveOut = null;
            }
            if (LeftwaveOut != null)
            {
                LeftwaveOut.Stop();
                LeftwaveOut.Dispose();
                LeftwaveOut = null;
            }
            if (BothwaveOut != null)
            {
                BothwaveOut.Stop();
                BothwaveOut.Dispose();
                BothwaveOut = null;
            }
            if (MixwaveOut != null)
            {
                MixwaveOut.Stop();
                MixwaveOut.Dispose();
                MixwaveOut = null;
            }
        }

        private void Button2_Click(object sender, EventArgs e)  //ステレオ発振 停止ボタン
        {
            StereoStop();

            button1.BackColor = Color.Silver;
            button14.BackColor = Color.Silver;
            button17.BackColor = Color.Silver;
            button25.BackColor = Color.Silver;
            rightOsc_bool = false;
            leftOsc_bool = false;
            bothOsc_bool = false;
            mixOsc_bool = false;
        }


        private void button3_Click(object sender, EventArgs e)  //モノラル発振 停止ボタン
        {
            if (ConwaveOut != null)
            {
                ConwaveOut.Stop();
                ConwaveOut.Dispose();
                ConwaveOut = null;
            }
            button5.BackColor = Color.Silver;
            conOsc_bool = false;
        }

        private void button4_Click(object sender, EventArgs e)　　//終了ボタン
        {
            Close();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e) //終了処理
        {
            StereoStop();

            if (ConwaveOut != null)
            {
                ConwaveOut.Stop();
                ConwaveOut.Dispose();
                ConwaveOut = null;
            }
        }

        //--------------------------------以下 音量関係 ---------------------------------------------

        private void button6_Click(object sender, EventArgs e) //音量　大　ボタン
        {
            amp = 19600;
            Oscillate();

            button6.BackColor = Color.LightSteelBlue;
            button7.BackColor = Color.Silver;
            button8.BackColor = Color.Silver;
        }

        private void button7_Click(object sender, EventArgs e)  //音量　中　ボタン
        {
            amp = 9800;
            Oscillate();

            button6.BackColor = Color.Silver;
            button7.BackColor = Color.LightSteelBlue;
            button8.BackColor = Color.Silver;
        }

        private void button8_Click(object sender, EventArgs e)  //音量　小　ボタン
        {
            amp = 3000;
            Oscillate();

            button6.BackColor = Color.Silver;
            button7.BackColor = Color.Silver;
            button8.BackColor = Color.LightSteelBlue;
        }

        private void Oscillate()    //各 boolean が true ならば発振する
        {
            if (rightOsc_bool == true)
            {
                RightOscillate();
            }
            if (leftOsc_bool == true)
            {
                LeftOscillate();
            }
            if (bothOsc_bool == true)
            {
                BothOscillate();
            }
            if (mixOsc_bool == true)
            {
                MixOscillate();
            }
            if (conOsc_bool == true)
            {
                continuousOscillate();
            }
        }
        //--------------------------------以上 音量関係 ---------------------------------------------

        private void radioButton1_CheckedChanged(object sender, EventArgs e)  //モノラル周波数倍率切り替え　1倍
        {
            X = 1;
            textBox2.Text = (trackBar1.Value * X).ToString();
            if (conOsc_bool == true)
            {
                Conoscillator.Pitch = ConCalculatePitch();
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)  //モノラル周波数倍率切り替え　10倍
        {
            X = 10;
            textBox2.Text = (trackBar1.Value * X).ToString();
            if (conOsc_bool == true)
            {
                Conoscillator.Pitch = ConCalculatePitch();
            }
        }

        //-------------------------- 以下 モノラル周波数 0.1 増加・減少関係  --------------------------------

        private void button12_Click(object sender, EventArgs e)   //周波数 0.1増加ボタン
        {
            string MonoStr = textBox2.Text;
            double MonoFrequency = 400.0;
            if (double.TryParse(MonoStr, out MonoFrequency))
            {
                if (MonoFrequency < 2200 * X)
                {
                    textBox2.Text = (MonoFrequency + 0.1 * X).ToString();
                }
                if (conOsc_bool == true)
                {
                    Conoscillator.Pitch = ConCalculatePitch();  //pitch計算
                }
                waveDis();  //波の表示
            }
        }

        private void button13_Click(object sender, EventArgs e)   //周波数　0.1減少ボタン
        {
            string MonoStr = textBox2.Text;
            double MonoFrequency = 400.0;
            if (double.TryParse(MonoStr, out MonoFrequency))
            {
                if (MonoFrequency > 1)
                {
                    textBox2.Text = (MonoFrequency - 0.1 * X).ToString();
                }
                if (conOsc_bool == true)
                {
                    Conoscillator.Pitch = ConCalculatePitch();  //pitch計算
                }
                waveDis();  //波の表示
            }
        }
        //------------- 以上 モノラル周波数 0.1 増加・減少関係  ------  以下 モノラル周波数１増関係  -----------------

        private void button21_MouseDown(object sender, MouseEventArgs e)  //周波数１増加ボタン（マウスダウン）
        {
            ADD1();
            timer1.Interval = 600;
            timer1.Enabled = true;
        }

        private void button21_MouseUp(object sender, MouseEventArgs e)  //周波数１増加停止（マウスアップ）
        {
            timer1.Enabled = false;
        }

        private void timer1_Tick(object sender, EventArgs e)   //timer1
        {
            ADD1();
            timer1.Interval = 100;
        }

        private void ADD1()   //周波数１増実行
        {
            if (trackBar1.Value < 2200)
            {
                trackBar1.Value = trackBar1.Value + 1;
            }
            textBox2.Text = (trackBar1.Value * X).ToString();
            if (conOsc_bool == true)
            {
                Conoscillator.Pitch = ConCalculatePitch();  //pitch計算
            }
            waveDis();  //波の表示      
        }
        //----------------------- 以上 モノラル周波数１増関係  以下　モノラル周波数１減関係-----------------------

        private void button22_MouseDown(object sender, MouseEventArgs e)    //周波数１減ボタン（マウスダウン）
        {
            REDUCE1();
            timer2.Interval = 600;
            timer2.Enabled = true;
        }

        private void button22_MouseUp(object sender, MouseEventArgs e)  //周波数１減停止（マウスアップ）
        {
            timer2.Enabled = false;
        }

        private void timer2_Tick(object sender, EventArgs e)   //timer2
        {
            REDUCE1();
            timer2.Interval = 100;
        }

        private void REDUCE1()  //周波数１減実行
        {
            if (trackBar1.Value > 1)
            {
                trackBar1.Value = trackBar1.Value - 1;
            }
            textBox2.Text = (trackBar1.Value * X).ToString();
            if (conOsc_bool == true)
            {
                Conoscillator.Pitch = ConCalculatePitch();  //Pitch計算
            }
            waveDis();  //波の表示      
        }
        //-----------------以上　モノラル周波数１減関係------------ 以下 左周波数１増関係  ----------------------

        private void button19_MouseDown(object sender, MouseEventArgs e)     //左周波数１増ボタン（マウスダウン）
        {
            LeftADD1();
            timer3.Interval = 600;
            timer3.Enabled = true;
        }

        private void button19_MouseUp(object sender, MouseEventArgs e)     //左周波数１増停止（マウスアップ）
        {
            timer3.Enabled = false;
        }

        private void timer3_Tick(object sender, EventArgs e)    //timer3
        {
            LeftADD1();
            timer3.Interval = 100;
        }

        private void LeftADD1()   //左周波数１増実行
        {
            string Str = textBox6.Text;
            int Lfq;
            if (int.TryParse(Str, out Lfq))
            {
                textBox6.Text = (Lfq + 1).ToString();
            }

            if (leftOsc_bool == true)
            {
                Leftoscillator.Pitch = LeftCalculatePitch();
            }
            else if(bothOsc_bool == true)
            {
                Bothoscillator.LeftPitch = LeftCalculatePitch();
                Bothoscillator.RightPitch = RightCalculatePitch();
            }
            else if(mixOsc_bool == true)
            {
                Mixoscillator.LeftPitch = LeftCalculatePitch();
                Mixoscillator.RightPitch = RightCalculatePitch();
            }

            waveDis();  //波の表示 
        }

        //-------------------------- 以上 左周波数１増関係    以下 左周波数１減関係------------------------------

        private void button20_MouseDown(object sender, MouseEventArgs e)   //左周波数１減ボタン（マウスダウン）
        {
            LeftREDUCE1();
            timer4.Interval = 600;
            timer4.Enabled = true;
        }

        private void button20_MouseUp(object sender, MouseEventArgs e)     //左周波数１減停止（マウスアップ）     
        {
            timer4.Enabled = false;
        }

        private void timer4_Tick(object sender, EventArgs e)    //timer4
        {
            LeftREDUCE1();
            timer4.Interval = 100;
        }

        private void LeftREDUCE1()   //左周波数１減実行
        {
            string Str = textBox6.Text;
            int Lfq;
            if (int.TryParse(Str, out Lfq))
            {
                if (Lfq > 1)
                {
                    textBox6.Text = (Lfq - 1).ToString();
                }
            }

            if (leftOsc_bool == true)
            {
                Leftoscillator.Pitch = LeftCalculatePitch();
            }
            else if (bothOsc_bool == true)
            {
                Bothoscillator.LeftPitch = LeftCalculatePitch();
                Bothoscillator.RightPitch = RightCalculatePitch();
            }
            else if (mixOsc_bool == true)
            {
                Mixoscillator.LeftPitch = LeftCalculatePitch();
                Mixoscillator.RightPitch = RightCalculatePitch();
            }
 
            waveDis();  //波の表示 
        }
        //----------------------- 以上 左周波数１減関係 ----- 以下 右周波数１増関係------------------------------

        private void button23_MouseDown(object sender, MouseEventArgs e)    //右周波数１増ボタン（マウスダウン）
        {
            RightADD1();
            timer5.Interval = 600;
            timer5.Enabled = true;
        }

        private void button23_MouseUp(object sender, MouseEventArgs e)    //右周波数１増停止（マウスアップ）
        {
            timer5.Enabled = false;
        }

        private void timer5_Tick(object sender, EventArgs e)    //timer5
        {
            RightADD1();
            timer5.Interval = 100;
        }

        private void RightADD1()   //右周波数１増実行
        {
            string Str = textBox1.Text;
            int Rfq;
            if (int.TryParse(Str, out Rfq))
            {
                textBox1.Text = (Rfq + 1).ToString();
            }

            if (rightOsc_bool == true)
            {
                Rightoscillator.Pitch = RightCalculatePitch();
            }
            else if (bothOsc_bool == true)
            {
                Bothoscillator.LeftPitch = LeftCalculatePitch();
                Bothoscillator.RightPitch = RightCalculatePitch();
            }
            else if (mixOsc_bool == true)
            {
                Mixoscillator.LeftPitch = LeftCalculatePitch();
                Mixoscillator.RightPitch = RightCalculatePitch();
            }

            waveDis();  //波の表示 
        }
        //--------------------------- 以上 右周波数１増関係  以下 右周波数１減関係------------------------------------

        private void button24_MouseDown(object sender, MouseEventArgs e)  //右周波数１減ボタン（マウスダウン）
        {
            RightREDUCE1();
            timer6.Interval = 600;
            timer6.Enabled = true;          
        }

        private void button24_MouseUp(object sender, MouseEventArgs e)     //右周波数１減停止（マウスアップ）
        {
            timer6.Enabled = false;
        }

        private void timer6_Tick(object sender, EventArgs e)    //timer6
        {
            RightREDUCE1();
            timer6.Interval = 100;
        }

        private void RightREDUCE1()  //右周波数１減実行
        {
            string Str = textBox1.Text;
            int Rfq;
            if (int.TryParse(Str, out Rfq))
            {
                if (Rfq > 1)
                {
                    textBox1.Text = (Rfq - 1).ToString();
                }
            }

            if (rightOsc_bool == true)
            {
                Rightoscillator.Pitch = RightCalculatePitch();
            }
            else if (bothOsc_bool == true)
            {
                Bothoscillator.LeftPitch = LeftCalculatePitch();
                Bothoscillator.RightPitch = RightCalculatePitch();
            }
            else if (mixOsc_bool == true)
            {
                Mixoscillator.LeftPitch = LeftCalculatePitch();
                Mixoscillator.RightPitch = RightCalculatePitch();
            }
 
            waveDis();  //波の表示 
        }
        //---------------------------------- 以上 右周波数１減関係--------------------------------------------

 

        //***************************************  以下　グラフ表示関係 *********************************************************

        private void button15_Click(object sender, EventArgs e)   //モノラル波グラフ表示ボタン
        {
            if (monograph_bool == false)
            {
                monograph_bool = true;
                button15.BackColor = Color.LightSteelBlue;
                MonoGraph();
            }
            else if (monograph_bool == true)
            {
                button15.BackColor = Color.Silver;
                monograph_bool = false;
            }
        }

        private void MonoGraph()  //モノラル波グラフ表示実行
        {
            Graphics g = this.pictureBox1.CreateGraphics();

            double monoAngle = 0;
            short[] array = new short[473];
            string Str = textBox2.Text;
            double i = 400;
            double frequency = 400;

            Line();

            if (double.TryParse(Str, out i))
            {
                frequency = i;
            }

             for (int n = 0; n < 472; n = n + 1)
            {
                array[n] = (short)(75 * Math.Sin(monoAngle));

                monoAngle -= 2 * Math.PI * frequency / 470 / T;
                if (monoAngle > 2 * Math.PI)
                {
                    monoAngle -= 2 * Math.PI;
                }
            }

            for (int n = 0; n < 472; n = n + 1)
            {
                g.DrawLine(Pens.Blue, n, array[n] + 150, n + 1, array[n + 1] + 150);
            }
        }


        private void button9_Click(object sender, EventArgs e)   //ステレオ左波グラフ表示ボタン
        {
           if (System.Text.RegularExpressions.Regex.IsMatch(textBox6.Text, "^[0-9]+$") == false)  // textBox6のテキストが整数値か判断する
            {
                MessageBox.Show("左周波数が整数値以外になってます。");
            }
           else if (System.Text.RegularExpressions.Regex.IsMatch(textBox1.Text, "^[0-9]+$") == false & textBox1.Text != "整数入力" & textBox1.Text != "")// textBox1のテキスト検査
           {
               MessageBox.Show("右周波数が整数値以外になってます。");
           }
           else if (leftgraph_bool == false  )      
           {
                leftgraph_bool = true;
                button9.BackColor = Color.LightSteelBlue;
                LeftGraph();
            }
            else if (leftgraph_bool == true)
            {
                button9.BackColor = Color.Silver;
                leftgraph_bool = false;
            }
        }

        private void LeftGraph()  //ステレオ左波グラフ表示実行
        {
            Graphics g = this.pictureBox1.CreateGraphics();

            double leftAngle = 0;
            double addAngle = hScrollBar2.Value / 4.0;
            short[] array = new short[473];
            string Str = textBox6.Text;
            double i = 400;
            double frequency = 400;

            Line();

            if (double.TryParse(Str, out i))
            {
                frequency = i;
            }

            //合成波移動用スクロールバー対応
            for (int n = 0; n < 472; n = n + 1)
            {
                if (textBox1.Text != "" & textBox1.Text != "整数入力")
                {
                    if (double.Parse(textBox6.Text) != int.Parse(textBox1.Text))
                    {
                        array[n] = (short)(75 * Math.Sin(leftAngle));
                    }
                    else if (double.Parse(textBox6.Text) == int.Parse(textBox1.Text))
                    {
                        array[n] = (short)(75 * Math.Sin(leftAngle + addAngle));
                    }
                }
                else if (textBox1.Text == "" )
                {
                    array[n] = (short)(75 * Math.Sin(leftAngle));
                }
                else if (textBox1.Text == "整数入力")
                {
                    array[n] = (short)(75 * Math.Sin(leftAngle));
                }

                leftAngle -= 2 * Math.PI * frequency / 470 / T;
                if (leftAngle > 2 * Math.PI)
                {
                    leftAngle -= 2 * Math.PI;
                }
            }

            for (int n = 0; n < 472; n = n + 1)
            {
                g.DrawLine(Pens.Red, n, array[n] + 150, n + 1, array[n + 1] + 150);
            }
        }


        private void button18_Click(object sender, EventArgs e)  //ステレオ右波グラフ表示ボタン
        {
           if (System.Text.RegularExpressions.Regex.IsMatch(textBox1.Text, "^[0-9]+$") == false)  // textBox1のテキストが整数値か判断する
            {
                MessageBox.Show("右周波数が整数値以外になってます。");
            }
           else if (System.Text.RegularExpressions.Regex.IsMatch(textBox6.Text, "^[0-9]+$") == false & textBox6.Text != "整数入力" & textBox6.Text != "")// textBox6のテキスト検査
           {
               MessageBox.Show("左周波数が整数値以外になってます。");
           }
           else if (rightgraph_bool == false )
           {
               rightgraph_bool = true;
               button18.BackColor = Color.LightSteelBlue;
               RightGraph();
           }
           else if (rightgraph_bool == true)
           {
               button18.BackColor = Color.Silver;
               rightgraph_bool = false;
           }
        }

        private void RightGraph()  //ステレオ右波グラフ表示実行（位相差を含める）
        {
            Graphics g = this.pictureBox1.CreateGraphics();

            double rightAngle = 0;
            double addAngle = hScrollBar2.Value / 4.0;
            short[] array = new short[473];
            string rightStr = textBox1.Text;
            string phaseStr = textBox3.Text;
            double Ri = 400;
            double frequency = 400;
            double Pi = 0;
            double PhaseDeff = 0;

            Line();

            if (double.TryParse(rightStr, out Ri))
            {
                frequency = Ri;
            }
            if (double.TryParse(phaseStr, out Pi))
            {
                PhaseDeff = Pi * Math.PI / 180;
            }

            //合成波移動用スクロールバー対応
            for (int n = 0; n < 472; n = n + 1)
            {
                if (textBox6.Text != "" & textBox6.Text != "整数入力")
                {
                    if (double.Parse(textBox6.Text) <= int.Parse(textBox1.Text))
                    {
                        array[n] = (short)(75 * Math.Sin(rightAngle + PhaseDeff + addAngle));
                    }
                    else if (double.Parse(textBox6.Text) > int.Parse(textBox1.Text))
                    {
                        array[n] = (short)(75 * Math.Sin(rightAngle + PhaseDeff - addAngle));
                    }
                }
                else if (textBox6.Text == "")
                {
                    array[n] = (short)(75 * Math.Sin(rightAngle + PhaseDeff));
                }
                else if (textBox6.Text == "整数入力")
                {
                    array[n] = (short)(75 * Math.Sin(rightAngle + PhaseDeff));
                }

                rightAngle -= 2 * Math.PI * frequency / 470 / T;
                if (rightAngle > 2 * Math.PI)
                {
                    rightAngle -= 2 * Math.PI;
                }
            }

            for (int n = 0; n < 472; n = n + 1)
            {
                g.DrawLine(Pens.Green, n, array[n] + 150, n + 1, array[n + 1] + 150);
            }
        }


        private void button16_Click(object sender, EventArgs e)　　//合成波グラフ表示ボタン
        {
            if (mixgraph_bool == false & leftgraph_bool == true & rightgraph_bool == true)
            {
                mixgraph_bool = true;
                button16.BackColor = Color.LightSteelBlue;
                MixGraph();
                hScrollBar2.Enabled = true;
            }
            else if (mixgraph_bool == true)
            {
                button16.BackColor = Color.Silver;
                mixgraph_bool = false;
                hScrollBar2.Enabled = false;
            }
        }


        void MixGraph()   //合成波グラフ表示実行
        {
            Graphics g = this.pictureBox1.CreateGraphics();
            double RightAngle = 0;
            double LeftAngle = 0;
            double PhaseDeff = 0;
            double addAngle = hScrollBar2.Value / 4.0;
            short[] array = new short[473];
            string RightStr = textBox1.Text;
            string LeftStr = textBox6.Text;
            string DeffStr = textBox3.Text;
            double Ri = 400;
            double Li = 400;
            double Di = 0;
            double Rightfrequency = 400;
            double Leftfrequency = 400;
            if (double.TryParse(RightStr, out Ri))
            {
                Rightfrequency = Ri;
            }
            if (double.TryParse(LeftStr, out Li))
            {
                Leftfrequency = Li;
            }
            if (double.TryParse(DeffStr, out Di))
            {
                PhaseDeff = Di * Math.PI / 180;
            }

            for (int n = 0; n < 472; n = n + 1)
            {
                if (double.Parse(textBox6.Text) < int.Parse(textBox1.Text))
                {
                    //波の配列　＝　ステレオ左波　＋　ステレオ右波（位相差含む）     （スクロールバーの移動角度addAngleを含む）
                    array[n] = (short)(75 * Math.Sin(LeftAngle) + 75 * Math.Sin(RightAngle + PhaseDeff + addAngle));
                }
                else if (double.Parse(textBox6.Text) > int.Parse(textBox1.Text))
                {
                    array[n] = (short)(75 * Math.Sin(LeftAngle) + 75 * Math.Sin(RightAngle + PhaseDeff - addAngle));
                }
                else if (double.Parse(textBox6.Text) == int.Parse(textBox1.Text))
                {
                    array[n] = (short)(75 * Math.Sin(LeftAngle + addAngle) + 75 * Math.Sin(RightAngle + PhaseDeff + addAngle));
                }

                RightAngle -= 2 * Math.PI * Rightfrequency / 470 / T;
                LeftAngle -= 2 * Math.PI * Leftfrequency / 470 / T;
                if (RightAngle > 2 * Math.PI)
                {
                    RightAngle -= 2 * Math.PI;
                }
                if (LeftAngle > 2 * Math.PI)
                {
                    LeftAngle -= 2 * Math.PI;
                }
            }

            for (int n = 0; n < 472; n = n + 1)
            {
                Pen boldPen = new Pen(Color.Black, 2);
                g.DrawLine(boldPen, n, array[n] + 150, n + 1, array[n + 1] + 150);
            }
        }


        private void hScrollBar2_Scroll(object sender, ScrollEventArgs e)  //合成波移動スクロールバー
        {
            if (mixgraph_bool == true )
            {
                waveDis();  //波の表示
            }
        }

 
        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)   //表示時間幅スクロールバー スクロール
        {
            T = Math.Pow(10, hScrollBar1.Value / 100.0);
            if (1000 / T >= 10)
            {
                textBox5.Text = Convert.ToSingle(1000 / T).ToString("F1");   //フルスケール表示 ミリ秒　小数点1位表示
            }
            else if (1000 / T < 10)
            {
                textBox5.Text = Convert.ToSingle(1000 / T).ToString("F2");   //フルスケール表示 ミリ秒　小数点2位表示
            }
            waveDis();
        }


        private void waveDis()  //波の表示
        {
            Clear();

            if (leftgraph_bool == false & monograph_bool == true & mixgraph_bool == false & rightgraph_bool == false)
            {
                MonoGraph();
            }
            if (leftgraph_bool == true & monograph_bool == false & mixgraph_bool == false & rightgraph_bool == false)
            {
                LeftGraph();
            }
            if (leftgraph_bool == false & monograph_bool == false & mixgraph_bool == false & rightgraph_bool == true)
            {
                RightGraph();
            }
            if (leftgraph_bool == true & monograph_bool == true & mixgraph_bool == false & rightgraph_bool == false)
            {
                LeftGraph();
                MonoGraph();
            }
            if (leftgraph_bool == false & monograph_bool == true & mixgraph_bool == false & rightgraph_bool == true)
            {
                MonoGraph();
                RightGraph();
            }
            if (leftgraph_bool == true & monograph_bool == false & mixgraph_bool == false & rightgraph_bool == true)
            {
                LeftGraph();
                RightGraph();
            }
            if (leftgraph_bool == true & monograph_bool == true & mixgraph_bool == false & rightgraph_bool == true)
            {
                LeftGraph();
                MonoGraph();
                RightGraph();
            }
            if (leftgraph_bool == true & monograph_bool == false & mixgraph_bool == true & rightgraph_bool == true)
            {
                LeftGraph();
                MixGraph();
                RightGraph();
            }
            if (leftgraph_bool == true & monograph_bool == true & mixgraph_bool == true & rightgraph_bool == true)
            {
                LeftGraph();
                MonoGraph();
                MixGraph();
                RightGraph();
            }
        }

        private void button10_Click(object sender, EventArgs e)   //グラフ消去
        {
            Clear();
            leftgraph_bool = false;
            monograph_bool = false;
            mixgraph_bool = false;
            rightgraph_bool = false;
            button9.BackColor = Color.Silver;
            button15.BackColor = Color.Silver;
            button18.BackColor = Color.Silver;
            button16.BackColor = Color.Silver;
            hScrollBar2.Enabled = false;
            hScrollBar2.Value = 0;
        }

        private void Clear()    //グラフ消去実行
        {
            Graphics g = this.pictureBox1.CreateGraphics();
            g.Clear(Color.White);
            Line();
        }


        private void button11_Click(object sender, EventArgs e)  //グラフ領域の「開」「閉」切り替えボタン
        {
            if (Vis_bool == true)
            {
                Vis_bool = false;
                button11.Text = "ｸﾞﾗﾌ開";
                this.Size = new Size(485, 221);
            }
            else if (Vis_bool == false)
            {
                Vis_bool = true;
                button11.Text = "ｸﾞﾗﾌ閉";
                this.Size = new Size(485, 637);
            }
        }

        private void Line()    //グラフの中心に水平の線を描画
        {
            Graphics g = this.pictureBox1.CreateGraphics();
            g.DrawLine(Pens.Gainsboro, 0, 150, 471, 150);
        }

        //***************************************  以上　グラフ表示関係 *********************************************************
    }


    //***********************************************************************************************
    //　　　　　　　　                     左発振用　Class
    //***********************************************************************************************

    class LeftOscillator : WaveProvider16  
    {
        double phaseAngle;

        public LeftOscillator(int sampleRate) 
            : base(sampleRate, 2)    //2:stereo,1:mono
        {
        }

        public LeftOscillator(int sampleRate, double pitch )  
            : this(sampleRate)
        {
            Pitch = pitch;
        }

        public double Pitch { set; get; }
        public short Amplitude { set; get; }

        public override int Read(short[] buffer, int offset, int sampleCount)
        {
            for (int index = 0; index < sampleCount; index = index + 2)
            {
                double pitch = Pitch;
                double frequency = PitchToFrequency(pitch);
                buffer[offset + index] = (short)(Amplitude * Math.Sin(phaseAngle));   // LEFT
                phaseAngle += 2 * Math.PI * frequency / WaveFormat.SampleRate;

                if (phaseAngle > 2 * Math.PI)
                {
                    phaseAngle -= 2 * Math.PI;
                }
            }
            return sampleCount;
        }

        double PitchToFrequency(double pitch)
        {
            return 440 * Math.Pow(2, (pitch - 69) / 12);
        }
    }


    //***********************************************************************************************
    //　　　　　　　　                     右発振用　Class
    //***********************************************************************************************

    class RightOscillator : WaveProvider16
    {
        double phaseAngle;

        public RightOscillator(int sampleRate)
            : base(sampleRate, 2)    //2:stereo,1:mono
        {
        }

        public RightOscillator(int sampleRate, double pitch, double phaseDeff)
            : this(sampleRate)
        {
            Pitch = pitch;
            PhaseDeff = phaseDeff;
        }

        public double Pitch { set; get; }
        public short Amplitude { set; get; }
        public double PhaseDeff { set; get; }

        public override int Read(short[] buffer, int offset, int sampleCount)
        {
            for (int index = 0; index < sampleCount; index = index + 2)
            {
                double pitch = Pitch;
                double frequency = PitchToFrequency(pitch);
                buffer[offset + index + 1] = (short)(Amplitude * Math.Sin(phaseAngle + PhaseDeff));  // RIGHT
                phaseAngle += 2 * Math.PI * frequency / WaveFormat.SampleRate;

                if (phaseAngle > 2 * Math.PI)
                {
                    phaseAngle -= 2 * Math.PI;
                }
            }
            return sampleCount;
        }

        double PitchToFrequency(double pitch)
        {
            return 440 * Math.Pow(2, (pitch - 69) / 12);
        }
    }

    //***********************************************************************************************
    //　　　　　　　                  　左右発振用　Class
    //***********************************************************************************************

    class BothOscillator : WaveProvider16
    {
        double LeftphaseAngle;
        double RightphaseAngle;

        public BothOscillator(int sampleRate)
            : base(sampleRate, 2)    //2:stereo,1:mono
        {
        }

        public BothOscillator(int sampleRate, double Leftpitch, double Rightpitch, double phaseDeff)
            : this(sampleRate)
        {
            LeftPitch = Leftpitch;
            RightPitch = Rightpitch;
            PhaseDeff = phaseDeff;
        }

        public double LeftPitch { set; get; }
        public double RightPitch { set; get; }
        public short Amplitude { set; get; }
        public double PhaseDeff { set; get; }

        public override int Read(short[] buffer, int offset, int sampleCount)
        {
            for (int index = 0; index < sampleCount; index = index + 2)
            {
                double Leftpitch = LeftPitch;
                double Rightpitch = RightPitch;
                double Leftfrequency = PitchToFrequency(Leftpitch);
                double Rightfrequncy = PitchToFrequency(Rightpitch);


                buffer[offset + index] = (short)(Amplitude * Math.Sin(LeftphaseAngle));   // LEFT
                buffer[offset + index + 1] = (short)(Amplitude * Math.Sin(RightphaseAngle + PhaseDeff));  // RIGHT
                LeftphaseAngle += 2 * Math.PI * Leftfrequency / WaveFormat.SampleRate;
                RightphaseAngle += 2 * Math.PI * Rightfrequncy / WaveFormat.SampleRate;

                if (LeftphaseAngle > 2 * Math.PI)
                {
                    LeftphaseAngle -= 2 * Math.PI;
                }
                if (RightphaseAngle > 2 * Math.PI)
                {
                    RightphaseAngle -= 2 * Math.PI;
                }
            }
            return sampleCount;
        }

        double PitchToFrequency(double pitch)
        {
            return 440 * Math.Pow(2, (pitch - 69) / 12);
        }
    }

   
        //***********************************************************************************************
        //　　　　　　　　                  混合発振用　Class
        //***********************************************************************************************

        class MixOscillator : WaveProvider16
        {
            double LeftphaseAngle;
            double RightphaseAngle;

            public MixOscillator(int sampleRate)
                : base(sampleRate, 2)    //2:stereo,1:mono
            {
            }

            public MixOscillator(int sampleRate, double Leftpitch, double Rightpitch, double phaseDeff)
                : this(sampleRate)
            {
                LeftPitch = Leftpitch;
                RightPitch = Rightpitch;
                PhaseDeff = phaseDeff;
            }

            public double LeftPitch { set; get; }
            public double RightPitch { set; get; }
            public short Amplitude { set; get; }
            public double PhaseDeff { set; get; }

            public override int Read(short[] buffer, int offset, int sampleCount)
            {
                for (int index = 0; index < sampleCount; index = index+2)
                {
                    double Leftpitch = LeftPitch;
                    double Rightpitch = RightPitch;
                    double Leftfrequency = PitchToFrequency(Leftpitch);
                    double Rightfrequncy = PitchToFrequency(Rightpitch);
                    buffer[offset + index] = (short)(Amplitude/1.3  * Math.Sin(LeftphaseAngle) + Amplitude /1.3 * Math.Sin(RightphaseAngle + PhaseDeff));　　//混合して左に出力
                                                                                                                                                             //音が割れるのでAmplitude/1.3にしてある
                    LeftphaseAngle += 2 * Math.PI * Leftfrequency / WaveFormat.SampleRate;
                    RightphaseAngle += 2 * Math.PI * Rightfrequncy / WaveFormat.SampleRate;

                    if (LeftphaseAngle > 2 * Math.PI)
                    {
                        LeftphaseAngle -= 2 * Math.PI;
                    }
                    if (RightphaseAngle > 2 * Math.PI)
                    {
                        RightphaseAngle -= 2 * Math.PI;
                    }
                }
                return sampleCount;
            }

            double PitchToFrequency(double pitch)
            {
                return 440 * Math.Pow(2, (pitch - 69) / 12);
            }
        }

    
    //***********************************************************************************************
    //　　　　　　　　　　　　　　　　モノラル（連続可変）発振用　Class
    //***********************************************************************************************
    
     class ConOscillator : WaveProvider16  　
    {
        double phaseAngle;
        double previousPitch;

        public ConOscillator(int sampleRate) 
            : base(sampleRate, 1)   //2:stereo,1:mono
        {
        }

        public ConOscillator(int sampleRate, double pitch) 
            : this(sampleRate)
        {
            Pitch = pitch;
            previousPitch = pitch;
        }

        public double Pitch { set; get; }
        public short Amplitude { set; get; }

        public override int Read(short[] buffer, int offset, int sampleCount)
        {
            for (int index = 0; index < sampleCount; index++)
            {
                double pitch;

                if (Pitch != previousPitch)
                {
                    pitch = ((sampleCount - index - 1) * previousPitch + Pitch) / (sampleCount - index);
                    previousPitch = pitch;
                }
                else
                {
                    pitch = Pitch;
                }

                double frequency = PitchToFrequency(pitch);
                buffer[offset + index] = (short)(Amplitude * Math.Sin(phaseAngle));
                phaseAngle += 2 * Math.PI * frequency / WaveFormat.SampleRate;

                if (phaseAngle > 2 * Math.PI)
                {
                    phaseAngle -= 2 * Math.PI;
                }
            }
            return sampleCount;
        }

        double PitchToFrequency(double pitch)
        {
            return 440 * Math.Pow(2, (pitch - 69) / 12);
        }
    }

 /*
        //**********************************************************************************************************
        //　　　　　　　不連続発振用　Class  
     　 //　上の〈モノラル（連続可変）発振用　Class〉を無効にし、このClassを有効にしてデバッグを実行すると不連続発振になる
        //**********************************************************************************************************


        class ConOscillator : WaveProvider16
        {
            double phaseAngle;

            public ConOscillator(int sampleRate)
                : base(sampleRate, 1)   //2:stereo,1:mono
            {
            }

            public ConOscillator(int sampleRate, double pitch)
                : this(sampleRate)
            {
                Pitch = pitch;
            }

            public double Pitch { set; get; }
            public short Amplitude { set; get; }

            public override int Read(short[] buffer, int offset, int sampleCount)
            {
                for (int index = 0; index < sampleCount; index++)
                {
                    double frequency = PitchToFrequency(Pitch);
                    buffer[offset + index] = (short)(Amplitude * Math.Sin(phaseAngle));
                    phaseAngle += 2 * Math.PI * frequency / WaveFormat.SampleRate;

                    if (phaseAngle > 2 * Math.PI)
                    {
                        phaseAngle -= 2 * Math.PI;
                    }
                }
                return sampleCount;
            }

            double PitchToFrequency(double pitch)
            {
                return 440 * Math.Pow(2, (pitch - 69) / 12);
            }
        }
*/  
  
}
